
#if true

using System;
using System.Windows.Forms;
using WinTabDotnet;
using System.Drawing;

namespace XELF {

	class StylusInput {
		static readonly bool available;
		private readonly WinTabMessenger messenger;
		private readonly WinTabContext context;
		private Point location;
		private float pressureScaling;
		private float pressure;

		static StylusInput() {
			available = WinTab.LoadWinTabLibrary();
		}

		public static bool Available { get { return available; } }

		public StylusInput(IntPtr WindowHandle) {
			if (available) {
				messenger = new WinTabMessenger();
				context = new WinTabContext();
				messenger.CursorMove += new CursorMoveHandler(move);
				messenger.NPressureChange += new NPressureChangeHandler(pressureChanged);
				messenger.ButtonDown += new ButtonDownHandler(buttonDown);
				messenger.ButtonUp += new ButtonUpHandler(buttonUp);
				pressureScaling = 1.0f / WinTab.DeviceNPressure.axMax;

				context.Open(WindowHandle, true, 0, 0, 1280, 800,// 8192, 8192,
					ContextOption.OFFMODE | ContextOption.SYSTEM,
					RelativeField.None);
			}
		}

		public event EventHandler Move;
		public event EventHandler PressureChanged;
		public event EventHandler ButtonDown;
		public event EventHandler ButtonUp;

		/// <summary>
		/// KΏۂ̃EBhEWndProc\bhɂbZ[W̃\bhɓ`Kv܂B
		/// </summary>
		/// <param name="m">bZ[W</param>
		/// <returns>falseԂƂɂ́AbZ[W̃EBhE̊NXŏ悤ɂ܂B</returns>
		public bool WndProc(ref Message m) {
			return messenger.WndProc(ref m);
		}
		public float Pressure { get { return pressure; } }
		public int X { get { return location.X; } }
		public int Y { get { return location.Y; } }
		public Point Location { get { return location; } }

		void pressureChanged(PacketEventArgs e) {
			pressure = e.pkts.pkNormalPressure * pressureScaling;
			if (PressureChanged != null)
				PressureChanged(this, EventArgs.Empty);
		}

		void move(PacketEventArgs e) {
			location.X = e.pkts.pkX;
			location.Y = e.pkts.pkY;
			if (Move != null)
				Move(this, EventArgs.Empty);
		}

		void buttonDown(PacketEventArgs e) {
			if (ButtonDown != null)
				ButtonDown(this, EventArgs.Empty);
		}
		void buttonUp(PacketEventArgs e) {
			if (ButtonUp != null)
				ButtonUp(this, EventArgs.Empty);
		}

	}
}

#endif
